/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_PTHREADWRAP_H
#define LWM2_PTHREADWRAP_H

#ifndef LWM2_NO_DLSYM
#ifdef LWM2_MEASUREMENT_PTHREAD

typedef void*(*fptr)(void*);

int pthread_create(pthread_t*            thread,
                   const pthread_attr_t* attr,
                   fptr                  start_function,
                   void*                 arg);

#endif
#endif

void lwm2_wrapper_pthread_init();

#endif
