#ifndef LWM2_CONFIG_H__
#define LWM2_CONFIG_H__

#include "src/config-common.h"
#include "src/config-backend-mpi.h"

//#include "src/config.h"

#define LWM2_SYSTEM_LINUX
#define LWM2_MEASUREMENT_MPI
#define LWM2_MEASUREMENT_OMP
#define LWM2_MEASUREMENT_PTHREAD
#define LWM2_MEASUREMENT_IO

#if HAVE(PAPI)
#define LWM2_MEASUREMENT_HWCOUNTER 
#define LWM2_MEASUREMENT_HWCOUNTER_PAPI
#endif

#if HAVE(CUDA)
#define LWM2_ENABLE_CUDA
#define LWM2_MEASUREMENT_CUDA
#endif

#if !HAVE(LIBDL)
#define LWM2_NO_DLSYM
#endif

#define LWM2_OUTPUT_LWM2FILE

#define LWM2_LOG_LEVEL 0
#define NEED_F2C_CONV

#endif
