/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_PULSE_THREAD_H_
#define LWM2_PULSE_THREAD_H_

#include "lwm2-config.h"

double lwm2_thread_get_time_till_time_slice();

struct timespec lwm2_thread_get_timespec_till_time_slice();

void lwm2_thread_start_pulse_thread();

void lwm2_end_pulse_thread();

void* lwm2_thread_pulse_function(void* pnull);

extern int lwm2_thread_is_pulse_thread;

extern unsigned long lwm2_first_time_slice_time;
extern unsigned long lwm2_last_time_slice_time;

extern unsigned long lwm2_first_pulse_time_slice_time;
extern unsigned long lwm2_last_pulse_time_slice_time;

void lwm2_thread_lock_time_slice_update_lock();
void lwm2_thread_unlock_time_slice_update_lock();

#endif
