/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "lwm2-measurement-io.h"

#include "../../adapter/io/lwm2-io-wrapper.h"
#include "../../lwm2-storage.h"

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>


void lwm2_measurement_setup_io(void)
{
	lwm2_wrapper_io_init();
}

void lwm2_measurement_teardown_io(void)
{
   
}

void lwm2_measurement_handle_signal_fileio()
{
	if(lwm2_storage_get_flag_fileio())
	{
		lwm2_storage_increment_signal_fileio();
	}
	
	if(lwm2_storage_get_flag_mpi_io())
	{
		lwm2_storage_increment_signal_mpi_io();
	}
}
