///****************************************************************************
//**  Copyright (c) 2011-2012                                                **
//**  German Research School for Simulation Sciences GmbH					   **
//**                                                                         **
//**  See the file COPYRIGHT in the package base directory for details       **
//****************************************************************************/

/*
 * 			DEPRECATED!!
 */


//
//#include "lwm2-output-storage.h"
//#include <stdlib.h>
//#include <stdio.h>
//#include <math.h>
//#include <sys/types.h>
//#include <unistd.h>
//
//#ifdef LWM2_OUTPUT_CUBE
//#include "../../external/cube/include/cube.h"
//#endif
//#include "../../util/util_time_measurement.h"
//#include "../../lwm2-system.h"
//#include "../../adapter/lwm2-mpi-adapter.h"
//#include "../../lwm2-signal.h"
//#include "../../lwm2-storage.h"
//#include "../../adapter/lwm2-mpi-adapter.h"
//#ifdef LWM2_OUTPUT_CUBE
//
//cube_t* cube_handle;
//
//cube_metric* signals_parent;
//cube_metric* signals_total;
//cube_metric* signals_serial;
//cube_metric* signals_mpi;
//cube_metric* signals_fileio;
//cube_metric* signals_cuda;
//
//cube_metric* metric_comm_bytes;
//cube_metric* metric_comm_bytes_p2p;
//cube_metric* metric_comm_bytes_p2p_sent;
//cube_metric* metric_comm_bytes_p2p_recv;
//cube_metric* metric_comm_bytes_coll;
//cube_metric* metric_comm_bytes_coll_sent;
//cube_metric* metric_comm_bytes_coll_recv;
//
//cube_metric* metric_comm_msgs;
//cube_metric* metric_comm_msgs_p2p;
//cube_metric* metric_comm_msgs_p2p_sent;
//cube_metric* metric_comm_msgs_p2p_recv;
//cube_metric* metric_comm_msgs_coll;
//
//cube_metric* metric_fileio;
//cube_metric* metric_fileio_bytes_read;
//cube_metric* metric_fileio_bytes_written;
//
//cube_metric* metric_cuda_bytes;
//cube_metric* metric_cuda_bytes_d2h;
//cube_metric* metric_cuda_bytes_h2d;
//
//cube_metric* metric_cuda_hwc_inst;
//cube_metric* metric_cuda_hwc_div_b;
//
//cube_metric* metric_hwc_cycles;
//cube_metric* metric_hwc_inst;
//cube_metric* metric_hwc_floins;
//cube_metric* metric_hwc_flops;
////cube_metric* metric_hwc_l1_ins_misses;
////cube_metric* metric_hwc_l1_ins_hits;
//cube_metric* metric_hwc_l1_data_misses;
//cube_metric* metric_hwc_l1_data_accesses;
//
//cube_metric* metric_max_threads;
//
//cube_metric* all_metrics[LWM2_METRIC_COUNT];
//
//#endif
//
//FILE* lwm2_metric_file;
//FILE* raw_metrics_file;
//
//unsigned int time_slice_ind;
//
//
//#ifdef LWM2_OUTPUT_CUBE
//cube_cnode** cnode_array;
//#endif
//
//double* proc_data;
//
//double* buff1;
//double* buff2;
//
//char* output_file_name = "lwm2_profiling_data.cube";
//
//void lwm2_output_storage_init()
//{
//#ifdef LWM2_OUTPUT_CUBE
//	cube_handle = cube_create();
//	
//	output_init_signals();
//	output_init_metric_comm();
//	output_init_metric_fileio();
//	output_init_metric_cuda();
//	output_init_metric_hwc();
//	output_init_metric_threads();
//	output_init_metric_array();
//	
//	output_init_time_slices();
//	output_init_processes();
//	
//	char* file_name = getenv("LWM2_OUTPUT_FILE_NAME");
//	
//	if(file_name == NULL)
//	{
//		file_name = output_file_name;
//	}
//
//	lwm2_metric_file = fopen(file_name,"w");
//
//	cube_write_def(cube_handle, lwm2_metric_file);
//	
//	proc_data = malloc(lwm2_mpi_comm_size * sizeof(/*metric_data_t*/ unsigned long long));
//	buff1 = malloc(lwm2_mpi_comm_size * sizeof(/*metric_data_t*/ unsigned long long));
//	buff2 = malloc(lwm2_mpi_comm_size * sizeof(/*metric_data_t*/ unsigned long long));
//	
//	time_slice_ind = 0;
//#endif
//}
//
//void lwm2_output_storage_write(/*metric_data_t* */ unsigned long long *metric_to_write, int comm_size, int count)
//{
//#ifdef LWM2_OUTPUT_CUBE
//	int proc_index, table_index, met_index;
//
//	for(table_index = 0; table_index < count; table_index++)
//	{
//		for(met_index = 0; met_index < LWM2_METRIC_COUNT; met_index++)
//		{
//			for(proc_index = 0; proc_index < comm_size; proc_index++)
//			{
//				proc_data[proc_index] = (double) metric_to_write[proc_index*count*LWM2_METRIC_COUNT + table_index*LWM2_METRIC_COUNT + met_index];
//				
//				if(met_index == LWM2_SIGNAL_TOTAL || met_index == LWM2_METRIC_P2P_SENT_BYTES || met_index == LWM2_METRIC_COLL_SENT_BYTES ||
//						met_index == LWM2_METRIC_P2P_SENT_MSGS || met_index == LWM2_METRIC_IO_READ_BYTES || met_index == LWM2_METRIC_CUDA_BYTES_TO_DEVICE)
//				{
//					buff1[proc_index] = 0;
//				}
//				
//				if(met_index == LWM2_METRIC_P2P_SENT_BYTES || met_index == LWM2_METRIC_P2P_SENT_MSGS)
//				{
//					buff2[proc_index] = 0;
//				}
//				
//				if(met_index <= LWM2_METRIC_CUDA_BYTES_TO_HOST)
//				{
//					buff1[proc_index] += proc_data[proc_index];
//				}
//				
//				if(met_index == LWM2_METRIC_P2P_SENT_BYTES || met_index == LWM2_METRIC_P2P_RECV_BYTES || 
//						met_index == LWM2_METRIC_COLL_SENT_BYTES || met_index == LWM2_METRIC_COLL_RECV_BYTES)
//				{
//					buff2[proc_index] += proc_data[proc_index];
//				}
//				
//				if(met_index == LWM2_METRIC_P2P_SENT_MSGS || met_index == LWM2_METRIC_P2P_RECV_MSGS || met_index == LWM2_METRIC_COLL_CALL_COUNT)
//				{
//					buff2[proc_index] += proc_data[proc_index];
//				}
//			}
//			output_write_metric(met_index);
//		}
//		time_slice_ind++;
//	}
//#endif
//}
//
//void lwm2_output_storage_end()
//{
//#ifdef LWM2_OUTPUT_CUBE
//	cube_write_finish(cube_handle, lwm2_metric_file);
//	cube_free(cube_handle);
//	fclose(lwm2_metric_file);
//
//	free(buff1);
//	free(buff2);
//	free(proc_data);
//	free(cnode_array);
//#endif
//}
//
//#ifdef LWM2_OUTPUT_CUBE
//void output_write_metric(int met_index)
//{
//	cube_metric* met = all_metrics[met_index];
//
//	if(time_slice_ind >= lwm2_time_slice_index)
//	{
//		return;
//	}
//	
//	if(met != NULL)
//	{
//		cube_write_sev_row(cube_handle, lwm2_metric_file, met, cnode_array[time_slice_ind], proc_data);
//		
//		if(met_index == LWM2_SIGNAL_CUDA)
//		{
//			cube_write_sev_row(cube_handle, lwm2_metric_file, signals_parent, cnode_array[time_slice_ind], buff1);
//		}
//		
//		if(met_index == LWM2_METRIC_P2P_RECV_BYTES)
//		{
//			cube_write_sev_row(cube_handle, lwm2_metric_file, metric_comm_bytes_p2p, cnode_array[time_slice_ind], buff1);
//			
//		}
//		
//		if(met_index == LWM2_METRIC_COLL_RECV_BYTES)	
//		{
//			cube_write_sev_row(cube_handle, lwm2_metric_file, metric_comm_bytes_coll, cnode_array[time_slice_ind], buff1);
//			cube_write_sev_row(cube_handle, lwm2_metric_file, metric_comm_bytes, cnode_array[time_slice_ind], buff2);
//		}
//
//		if(met_index == LWM2_METRIC_P2P_RECV_MSGS)
//		{
//			cube_write_sev_row(cube_handle, lwm2_metric_file, metric_comm_msgs_p2p, cnode_array[time_slice_ind], buff1);
//		}
//
//		if(met_index == LWM2_METRIC_COLL_CALL_COUNT)
//		{
//			cube_write_sev_row(cube_handle, lwm2_metric_file, metric_comm_msgs, cnode_array[time_slice_ind], buff2);
//		}
//
//		if(met_index == LWM2_METRIC_IO_WRITE_BYTES)
//		{
//			cube_write_sev_row(cube_handle, lwm2_metric_file, metric_fileio, cnode_array[time_slice_ind], buff1);
//		}
//		
//		if(met_index == LWM2_METRIC_CUDA_BYTES_TO_HOST)
//		{
//			cube_write_sev_row(cube_handle, lwm2_metric_file, metric_cuda_bytes, cnode_array[time_slice_ind], buff1);
//		}
//	}
//}
//
//void output_init_signals()
//{
//	signals_parent = cube_def_met(cube_handle, "Signals", "Signals", "INTEGER", "occ", "", "", "Signals", NULL);
//	signals_total = cube_def_met(cube_handle, "Total Signals", "Total Signals", "INTEGER", "occ", "", "", "Total Signals", signals_parent);
//	signals_serial = cube_def_met(cube_handle, "Serial Signals", "Serial Signals", "INTEGER", "occ", "", "", "Serial Signals", signals_parent);
//	signals_mpi = cube_def_met(cube_handle, "MPI Signals", "MPI Signals", "INTEGER", "occ", "", "", "MPI Signals", signals_parent);
//	signals_fileio = cube_def_met(cube_handle, "File I/O Signals", "File I/O Signals", "INTEGER", "occ", "", "", "File I/O Signals", signals_parent);
//	signals_cuda = cube_def_met(cube_handle, "CUDA Signals", "CUDA Signals", "INTEGER", "occ", "", "", "CUDA Signals", signals_parent);
//}
//
//void output_init_metric_comm()
//{
//	metric_comm_bytes = cube_def_met(cube_handle, "Bytes Transferred", "Bytes Transferred", "INTEGER", "occ", "", "", "Bytes Transferred", NULL);
//	metric_comm_bytes_p2p = cube_def_met(cube_handle, "P2P Bytes Transferred", "P2P Bytes Transferred", "INTEGER", "occ", "", "", "P2P Bytes Transferred", metric_comm_bytes);
//	metric_comm_bytes_p2p_sent = cube_def_met(cube_handle, "P2P Bytes Sent", "P2P Bytes Sent", "INTEGER", "occ", "", "", "P2P Bytes Sent", metric_comm_bytes_p2p);
//	metric_comm_bytes_p2p_recv = cube_def_met(cube_handle, "P2P Bytes Received", "P2P Bytes Received", "INTEGER", "occ", "", "", "P2P Bytes Received", metric_comm_bytes_p2p);
//	metric_comm_bytes_coll = cube_def_met(cube_handle, "Collective Bytes Transferred", "Collective Bytes Transferred", "INTEGER", "occ", "", "", "Collective Bytes Transferred", metric_comm_bytes);
//	metric_comm_bytes_coll_sent = cube_def_met(cube_handle, "Collective Bytes Sent", "Collective Bytes Sent", "INTEGER", "occ", "", "", "Collective Bytes Sent", metric_comm_bytes_coll);
//	metric_comm_bytes_coll_recv = cube_def_met(cube_handle, "Collective Bytes Received", "Collective Bytes Received", "INTEGER", "occ", "", "", "Collective Bytes Received", metric_comm_bytes_coll);
//	
//	metric_comm_msgs = cube_def_met(cube_handle, "MPI Messages", "MPI Messages", "INTEGER", "occ", "", "", "MPI Messages", NULL);
//	metric_comm_msgs_p2p = cube_def_met(cube_handle, "MPI  P2P Messages", "MPI  P2P Messages", "INTEGER", "occ", "", "", "MPI  P2P Messages", metric_comm_msgs);
//	metric_comm_msgs_p2p_sent = cube_def_met(cube_handle, "MPI  P2P Messages Sent", "MPI  P2P Messages Sent", "INTEGER", "occ", "", "", "MPI  P2P Messages Sent", metric_comm_msgs_p2p);
//	metric_comm_msgs_p2p_recv = cube_def_met(cube_handle, "MPI  P2P Messages Received", "MPI  P2P Messages Received", "INTEGER", "occ", "", "", "MPI  P2P Messages Received", metric_comm_msgs_p2p);
//	metric_comm_msgs_coll = cube_def_met(cube_handle, "MPI Collective Messages", "MPI Collective Messages", "INTEGER", "occ", "", "", "MPI Collective Messages", metric_comm_msgs);
//}
//
//void output_init_metric_fileio()
//{
//	metric_fileio = cube_def_met(cube_handle, "File I/O", "File I/O", "INTEGER", "occ", "", "", "File I/O", NULL);
//	metric_fileio_bytes_read = cube_def_met(cube_handle, "File I/O, Bytes Read", "File I/O, Bytes Read", "INTEGER", "occ", "", "", "File I/O, Bytes Read", metric_fileio);
//	metric_fileio_bytes_written = cube_def_met(cube_handle, "File I/O, Bytes Written", "File I/O, Bytes Written", "INTEGER", "occ", "", "", "File I/O, Bytes Written", metric_fileio);
//}
//
//void output_init_metric_cuda()
//{
//	metric_cuda_bytes = cube_def_met(cube_handle, "CUDA Bytes Transferred", "CUDA Bytes Transferred", "INTEGER", "occ", "", "", "CUDA Bytes Transferred", NULL);
//	metric_cuda_bytes_d2h = cube_def_met(cube_handle, "Device to Host", "Device to Host", "INTEGER", "occ", "", "", "Device to Host", metric_cuda_bytes);
//	metric_cuda_bytes_h2d = cube_def_met(cube_handle, "Host to Device", "Host to Device", "INTEGER", "occ", "", "", "Host to Device", metric_cuda_bytes);
//	
//	metric_cuda_hwc_inst = cube_def_met(cube_handle, "CUDA HWC Instructions", "CUDA HWC Instructions", "INTEGER", "occ", "", "", "CUDA HWC Instructions", NULL);
//	metric_cuda_hwc_div_b = cube_def_met(cube_handle, "CUDA HWC Divergent Branches", "CUDA HWC Divergent Branches", "INTEGER", "occ", "", "", "CUDA HWC Divergent Branches", NULL);
//}
//
//void output_init_metric_hwc()
//{
//	metric_hwc_inst = cube_def_met(cube_handle, "HWC Cycles", "HWC Cycles", "INTEGER", "occ", "", "", "HWC Cycles", NULL);
//	metric_hwc_inst = cube_def_met(cube_handle, "HWC Instructions", "HWC Instructions", "INTEGER", "occ", "", "", "HWC Instructions", NULL);
//	metric_hwc_flops = cube_def_met(cube_handle, "HWC FL Operations", "HWC FL Operations", "INTEGER", "occ", "", "", "HWC FL Operations", NULL);
//	metric_hwc_flops = cube_def_met(cube_handle, "HWC FLOPS", "HWC FLOPS", "INTEGER", "occ", "", "", "HWC FLOPS", NULL);
////	metric_hwc_l1_ins_misses = cube_def_met(cube_handle, "HWC L1 Ins Misses", "HWC L1 Ins Misses", "INTEGER", "occ", "", "", "HWC L1 Ins Misses", NULL);
////	metric_hwc_l1_ins_hits = cube_def_met(cube_handle, "HWC L1 Ins Hits", "HWC L1 Ins Hits", "INTEGER", "occ", "", "", "HWC L1 Ins Hits", NULL);
//	metric_hwc_l1_data_misses = cube_def_met(cube_handle, "HWC L1 Data Misses", "HWC L1 Data Misses", "INTEGER", "occ", "", "", "HWC L1 Data Misses", NULL);
//	metric_hwc_l1_data_accesses = cube_def_met(cube_handle, "HWC L1 Data Accesses", "HWC L1 Data Accesses", "INTEGER", "occ", "", "", "HWC L1 Data Accesses", NULL);
//}
//
//void output_init_metric_threads()
//{
//	metric_max_threads = cube_def_met(cube_handle, "Max. Threads", "Max. Threads", "INTEGER", "occ", "", "", "Max. Threads", NULL);
//}
//
//void output_init_metric_array()
//{
//	all_metrics[LWM2_SIGNAL_TOTAL] = signals_total;
//	all_metrics[LWM2_SIGNAL_SERIAL] = signals_serial;
//	all_metrics[LWM2_SIGNAL_MPI] = signals_mpi; 
//	all_metrics[LWM2_SIGNAL_FILE_IO] = signals_fileio;
//	all_metrics[LWM2_SIGNAL_CUDA] = signals_cuda;
//	all_metrics[LWM2_METRIC_P2P_SENT_BYTES] = metric_comm_bytes_p2p_sent;
//	all_metrics[LWM2_METRIC_P2P_SENT_MSGS] = metric_comm_msgs_p2p_sent;
//	all_metrics[LWM2_METRIC_P2P_RECV_BYTES] = metric_comm_bytes_p2p_recv;
//	all_metrics[LWM2_METRIC_P2P_RECV_MSGS] = metric_comm_msgs_p2p_recv;
//	all_metrics[LWM2_METRIC_COLL_SENT_BYTES] = metric_comm_bytes_coll_sent;
//	all_metrics[LWM2_METRIC_COLL_RECV_BYTES] = metric_comm_bytes_coll_recv;
//	all_metrics[LWM2_METRIC_COLL_CALL_COUNT] = metric_comm_msgs_coll;
//	all_metrics[LWM2_METRIC_IO_READ_BYTES] = metric_fileio_bytes_read;
//	all_metrics[LWM2_METRIC_IO_WRITE_BYTES] = metric_fileio_bytes_written;
//	all_metrics[LWM2_METRIC_CUDA_BYTES_TO_DEVICE] = metric_cuda_bytes_h2d;
//	all_metrics[LWM2_METRIC_CUDA_BYTES_TO_HOST] = metric_cuda_bytes_d2h;
//	all_metrics[LWM2_METRIC_CUDA_INSTRUCTIONS] = metric_cuda_hwc_inst;
//	all_metrics[LWM2_METRIC_CUDA_DIVERGENT] = metric_cuda_hwc_div_b;
//	all_metrics[LWM2_METRIC_CYCLES] = metric_hwc_cycles;
//	all_metrics[LWM2_METRIC_FLOINS] = metric_hwc_floins;
//	all_metrics[LWM2_METRIC_FLOPS] = metric_hwc_flops;
//	all_metrics[LWM2_METRIC_INSTRUCTIONS] = metric_hwc_inst;
//	all_metrics[LWM2_METRIC_L1_DATA_ACCESS] = metric_hwc_l1_data_accesses;
//	all_metrics[LWM2_METRIC_L1_DATA_MISSES] = metric_hwc_l1_data_misses;
//	all_metrics[LWM2_METRIC_MAX_NUM_THREADS] = metric_max_threads;
//}
//
//void output_init_time_slices()
//{
//	int i;
//	cube_region* reg;
//	cube_cnode* cnd;
//	char region_name[32];
//	char cnode_name[32];
//	
//	long time_int_part = (long) floor(lwm2_first_time_slice); 
//
//	int time_slices = (lwm2_time_slice_index - 1) % LWM2_STORAGE_SLICE;
//	time_slices = lwm2_time_slice_index - time_slices - 1 + LWM2_STORAGE_SLICE;
//
//	cnode_array = malloc(time_slices * sizeof(cube_cnode*));
//
//	for(i = 0; i < time_slices; i++)
//	{
//		sprintf(region_name, "Region %d, %ld", i + 1, (time_int_part + lwm2_time_slice_duration * i));
//		sprintf(cnode_name, "Time slice %d, %ld", i + 1, (time_int_part + lwm2_time_slice_duration * i));
//		
//		reg = cube_def_region(cube_handle, region_name, 0, 1, "", "", "");
//
//		cnd = cube_def_cnode(cube_handle, reg, NULL);
//		
//		cnode_array[i] = cnd;
//	}
//}
//
//void output_init_processes()
//{
//	int i;
//	
//	char name_buff[32];
//	
//	cube_node* nod;
//	cube_process* proc;
//	cube_thread* thrd;
//	
//	cube_machine* machine = cube_def_mach(cube_handle, "Machine", "");
//	
//	char prev_name[32];
//	cube_node* prev_node = NULL;
//
//	for(i = 0; i < lwm2_mpi_comm_size; i++)
//	{
//		if(lwm2_host_table != NULL)
//		{
//			sprintf(name_buff, "%s", &lwm2_host_table[i * HOSTNAME_LENGTH]);
//		}
//		else
//		{
//			sprintf(name_buff, "node %d", i);
//		}
//		
//		if(strcmp(prev_name, name_buff) == 0)
//		{
//			nod = prev_node;
//		}
//		else
//		{
//			nod = cube_def_node(cube_handle, name_buff, machine);
//		}
//		
//		strcpy(prev_name, name_buff);
//		prev_node = nod;
//		
//		sprintf(name_buff, "process %d", i);
//		proc = cube_def_proc(cube_handle, name_buff, i, nod);
//		
//		sprintf(name_buff, "thread %d", i);
//		thrd = cube_def_thrd(cube_handle, name_buff, 0, proc);
//	}
//}
//
//#endif
//
