/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_OPENMP_ADAPTER_H_
#define LWM2_OPENMP_ADAPTER_H_

#include <signal.h>

enum 
{
	LWM2_OMP_SIGNAL_HIT,
	LWM2_OMP_COND_TIMEDWAIT
};

extern unsigned char lwm2_thread_id;

#define LWM2_OMP_COUNT 2

void lwm2_wrapper_omp_init();

#ifndef LWM2_NO_DLSYM
void omp_set_num_threads(int n);
#endif

#endif
