/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef H_LWM2_MEASUREMENT_DEFAULT
#define H_LWM2_MEASUREMENT_DEFAULT

/**
 * Initializes the default measurement module
 */
void lwm2_measurement_setup_default(void);

/**
 * Tears down the default measurement module
 */
void lwm2_measurement_teardown_default(void);

/**
 * Handles one signal in the given process with the elapsed time since the
 * last signal
 */
void lwm2_measurement_handle_signal_default();

#endif
