/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef H_LWM2_MEASUREMENT_PAPI
#define H_LWM2_MEASUREMENT_PAPI

#include "../../adapter/lwm2-hwc-adapter.h"

extern unsigned long lwm2_hwc_last_read_duration;

/* Interface */
void lwm2_measurement_setup_hwcounter(void);
void lwm2_measurement_teardown_hwcounter(void);

void lwm2_measurement_handle_signal_hwcounter();

#ifdef LWM2_MEASUREMENT_HWCOUNTER
void lwm2_measurement_hwc_papi_read_reset_events(struct lwm2_hwc_storage* hwc_storage);
#endif

#endif
