/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/* Standard header */
#define _GNU_SOURCE
#include <dlfcn.h>
#include <stdio.h>
#include <signal.h>


/* Specific header */
#include "lwm2-measurement-pthread.h"

/* pthreads wrapper */
#include "../../adapter/lwm2-pthread-adapter.h"
#include "../../adapter/pthread/lwm2-pthreadwrap.h"

/**
 * Module setup
 */
void lwm2_measurement_setup_pthread(void)
{
	/* Init wrapper */
	lwm2_adapter_pthread_init();
}

/**
 * Module teardown
 */
void lwm2_measurement_teardown_pthread(void)
{
	/* Teardown wrapper */
	lwm2_adapter_pthread_destroy();
}

