/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_OUTPUT_FILE_H_
#define LWM2_OUTPUT_FILE_H_

#define FILENAME_LEN 1024

extern char lwm2_output_l2f_filename[FILENAME_LEN];
extern char* lwm2_output_filename_p;

void lwm2_output_file_init();

void lwm2_output_file_write_data(int count, unsigned long long *metrics_data);
void lwm2_output_file_write_definition_file();
void lwm2_output_file_write_non_mpi_definition_file();
void lwm2_output_file_write_summary_file();
void lwm2_output_file_write_non_mpi_summary_file();
void lwm2_output_file_write_time_slice_file();
void lwm2_output_file_write_non_mpi_time_slice_file();
void lwm2_output_file_write_file();
void lwm2_output_file_write_non_mpi_app_file();

void lwm2_output_file_write_file();

void lwm2_output_file_get_l2f_filename();

int lwm2_get_time_slice_count(unsigned long start_time, unsigned long end_time);

#endif
