/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/*
 * lwm2-log.h
 *
 *  Created on: Jun 7, 2011
 *      Author: schleiden
 */

#ifndef LWM2_LOG_H_
#define LWM2_LOG_H_

#define LWM2LOG(l,...) if(l <= LWM2_LOG_LEVEL) printf(__VA_ARGS__)

#define STR_LINE STRING(__LINE__)
#define STR_FILE __FILE__
#define LWM2TRACE(l,...) if(l <= LWM2_TRACE_LEVEL) printf("lwm2:" STR_FILE ":" STR_LINE ">" __VA_ARGS__)

enum {
	LWM2_SUCCESS = 0,
	LWM2_ERROR = 1
};


#endif /* LWM2_LOG_H_ */
