/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/* Standard header */
#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <stdint.h>

/* Local header */
#include "util_time_measurement.h"

timestamp_t util_get_timestamp()
{
	timestamp_t tstamp;

	struct timeval tv;

	gettimeofday(&tv, NULL);
	tstamp = (double) tv.tv_sec + (double) 1e-6 * tv.tv_usec;

	return tstamp;
}

unsigned long lwm2_util_get_long_time()
{
	time_t long_time = time(NULL);
	
	return long_time;
}

struct timespec lwm2_util_get_timespec_time()
{
	struct timespec tspc;
	
	clock_gettime(CLOCK_REALTIME, &tspc);
	
	return tspc;
}
