/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/*
 * util_time_measurement.h
 *
 *  Created on: May 17, 2011
 *      Author: schleiden
 */

#ifndef UTIL_TIME_MEASUREMENT_H_
#define UTIL_TIME_MEASUREMENT_H_

#include "../lwm2-config.h"

/**
 * Type representing a single timestamp
 */
typedef double timestamp_t;

/**
 * Type representing a single timespan
 */
typedef double timespan_t;

/**
 * Null timespan TODO
 */
#define timespan_t_null (0)


/**
 * Returns the current timestamp in seconds.useconds
 */
timestamp_t util_get_timestamp();

unsigned long lwm2_util_get_long_time();

struct timespec lwm2_util_get_timespec_time();

#endif /* UTIL_TIME_MEASUREMENT_H_ */
